global quasiCrystals2

rollout quasiCrystals2 "quasiCrystals2 - 3D pattern analyzer" width:248 height:370
			(
				local maintitle="quasiCrystals2"
				local copyright="(c)2013 by santex"
				local cfgdir=((getdir #maxroot)+"plugcfg\\santexTools\\quasiCrystals2\\")
				local configfile=(((getdir #maxroot)+"plugcfg\\santexTools\\quasiCrystals2\\")+"quasiCrystals2.ini")
				local devlogfile=(((getdir #maxroot)+"plugcfg\\santexTools\\quasiCrystals2\\")+"quasiCrystals2.log")
				global all_objects=#()
				
				local obj_types = #("Point","Geosphere","Box","Pyramid")
				
				
				listbox lbx_vars "Variables:" height:7
				edittext edt_var_name "Variable name:"
				spinner spn_var_val "Value:" type:#float range:[0,9999,0]
				--button btn_add_var "Add new variable" width:210
				button btn_rem_var "Remove selected variable" width:210
				/*

EXAMPLE: (define '_angle, _dist, _z' variables !!!)
				
if(d_angle>360)do d_angle=d_angle-360
pos_x=(cos d_angle)*(_i*_dist)
pos_y=(sin d_angle)*(_i*_dist)
pos_z=(_z*_i)
_this.pos=[pos_x,pos_y,pos_z]
d_angle+=_angle

				
				
				listbox lbx_rules "Rules:" height:8
				button btn_add_rule "Add rule for every iteration" width:210
				button btn_rem_rule "Remove selected rule" width:210
				*/
				
				label lbl1 "Evaluation code:"
				edittext edt_eval "" height:166
				
				
				button btn_load_config "Load configuration" width:210
				button btn_save_config "Save current configuration" width:210
				label lbl2 "--------------------------------------------------" enabled:false
				
				checkbox chk_autoupdate "Auto-execute"
				button btn_exec "EXECUTE" width:210
				spinner spn_iterations "Iterations" range:[0,1597,377] type:#integer tooltip:"Number of iterations (objects created)"
				spinner spn_seed "Random seed:" type:#integer
				dropdownlist ddl_obj_type "Object type:" items:obj_types
				spinner spn_obj_size "Object size" type:#float range:[0,9999,20]
				spinner spn_obj_quality "Object quality" type:#integer range:[1,19,3]
				colorpicker clr_wire_color "Wireframe color:" color:(color 160 190 50)
				checkbox chk_random_color "Random wireframe color"
				
				
				
				include "santex_fnlib.ms"
				
				fn getParsedEval=
				(
					local temp = edt_eval.text
					--seek temp 0
					--return (readvalue temp ignoreStringEscapes:true)
					/*local temp = edt_eval.text as stringstream
					local temp1 = ""
					(while peekToken a != undefined do (temp1 += ((readToken a) + ";");ok))*/
					local parsed = ""
					for i=1 to edt_eval.text.count do
					(
						if (edt_eval.text[i]=="\n") then parsed += ";"
						else parsed += edt_eval.text[i]
					)
					
					return parsed
				)
				fn getReParsedEval str=
				(
					local temp = str
					local parsed = ""
					for i=1 to str.count do
					(
						if (str[i]==";") then parsed += "\n"
						else parsed += str[i]
					)
					
					return parsed
				)
				fn getVarsSave=
				(
					local temp = ""
					for i=1 to lbx_vars.items.count do
					(
						local var = lbx_vars.items[i]
						temp += (var + ";")
					)					
					return temp
				)
				fn saveAllSettings=
				(
					slib.setting.save "iterations" spn_iterations.value
					slib.setting.save "obj_type" ddl_obj_type.selection
					slib.setting.save "random_color" chk_random_color.checked
					slib.setting.save "autoupdate" chk_autoupdate.checked
					slib.setting.save "eval" (getParsedEval())
					slib.setting.save "obj_size" spn_obj_size.value
					slib.setting.save "obj_quality" spn_obj_quality.value
						
					slib.setting.save "vars" (getVarsSave())
				)
				fn loadAllSettings=
				(
					spn_iterations.value=slib.setting.load "iterations" 377
					ddl_obj_type.selection=slib.setting.load "obj_type" 1
					chk_random_color.checked=slib.setting.load "random_color" false
					chk_autoupdate.checked=slib.setting.load "autoupdate" false
					edt_eval.text=getReParsedEval (slib.setting.loadStr "eval" "")
					spn_obj_size.value=slib.setting.load "obj_size" 20
					spn_obj_quality.value=slib.setting.load "obj_quality" 3
					
					lbx_vars.items = slib.sarray.getarray (slib.setting.loadStr "vars" "") ";" 0
				)
				
				
				fn deleteAllObjects=
				(
					for i=1 to all_objects.count do
					(
						try (delete all_objects[i])catch()
					)
				)
				
				
				fn getVarsNames=
				(
					local temp = #()
					for i=1 to lbx_vars.items.count do
					(
						local var_name = filterString lbx_vars.items[i] " = "
						append temp (var_name[1])
					)
					
					return temp
				)
				fn getVars=
				(
					local temp = ""
					for i=1 to lbx_vars.items.count do
					(
						local var = lbx_vars.items[i]
						temp += ("global " + var + "; ")
					)
					
					return temp
				)
				fn addVar=
				(
					local vars = getVarsNames()
					if (edt_var_name.text!="" AND edt_var_name.text.count!=0 AND (findItem vars edt_var_name.text)==0 AND edt_var_name.text!="_this" AND edt_var_name.text!="_i") then
					(
						local temp = lbx_vars.items
						append temp (edt_var_name.text + " = " + spn_var_val.value as string)
						lbx_vars.items = temp
						lbx_vars.selection = lbx_vars.items.count
					)
				)
				fn updateVar=
				(
					local temp = #()
					for i=1 to lbx_vars.items.count do
					(
						local var = filterString lbx_vars.items[i] " = "
						if (edt_var_name.text==var[1]) then
						(
							var[2] = spn_var_val.value
						)
						append temp (var[1] + " = " + var[2] as string)
					)
					lbx_vars.items = temp
				)
				
				fn createObject=
				(
					local new_obj
					local size = spn_obj_size.value
					if (ddl_obj_type.selection==1) do new_obj = point size:size centermarker:false cross:true axistripod:false axisLength:size
					if (ddl_obj_type.selection==2) do new_obj = geoSphere  radius:(size/2) segments:spn_obj_quality.value
					if (ddl_obj_type.selection==3) do new_obj = box length:size width:size height:size
					if (ddl_obj_type.selection==4) do new_obj = pyramid depth:size width:size height:(size/1.618)
					append all_objects new_obj
					return new_obj
				)
				fn setWireColor=
				(
					local wire_color = clr_wire_color.color
					if (chk_random_color.checked) do wire_color = (color (random 0 255) (random 0 255) (random 0 255))
					return wire_color
				)
				
				fn update_quasiCrystals=
				(
					undo off
					(
					
						deleteAllObjects()
						
						global _i = 1
						
						local define_vars=getVars()
						execute(define_vars)
						
						for i=1 to spn_iterations.value do
						(
							global _this = createObject()
							_this.wirecolor = setWireColor()
							
							--execute(edt_eval.text)
							try(execute(edt_eval.text))catch()
							_i += 1
						)
					
					)
					
					gc()
					clearUndoBuffer()
					completeRedraw()
				)
				
				--on btn_add_var pressed do addVar()
				on btn_rem_var pressed do
				(
					local temp = lbx_vars.items
					try(deleteItem temp lbx_vars.selection)catch()
					lbx_vars.items = temp
					lbx_vars.selection = lbx_vars.items.count
				)
				on edt_var_name entered arg do addVar()
				on spn_var_val changed val do (
					updateVar()
					if chk_autoupdate.checked do update_quasiCrystals()
				)
				on lbx_vars selected sel do
				(
					local var = filterString (lbx_vars.items[sel]) " = "
					edt_var_name.text = var[1]
					spn_var_val.value = var[2] as float
				)
				
				
				
				on btn_add_rule pressed do
				(
					fileIn "quasiCrystals2_addrule.ms"
				)
				on btn_rem_rule pressed do
				(
					local temp = lbx_rules.items
					try(deleteItem temp lbx_rules.selection)catch()
					lbx_rules.items = temp
					lbx_rules.selection = lbx_rules.items.count
				)
				
				on quasiCrystals2 open do
				(
					slib.file.init configfile "config"
					loadAllSettings()
					if chk_autoupdate.checked do update_quasiCrystals()
				)
				
				on quasiCrystals2 close do
				(
					deleteAllObjects()
					saveAllSettings()
					gc()
				)
				
				on btn_exec pressed do update_quasiCrystals()
				on spn_iterations changed val do if chk_autoupdate.checked do update_quasiCrystals()
				on spn_obj_size changed val do if chk_autoupdate.checked do update_quasiCrystals()
				on spn_obj_quality changed val do if chk_autoupdate.checked do update_quasiCrystals()
				on chk_random_color changed val do if chk_autoupdate.checked do update_quasiCrystals()
				on chk_autoupdate changed val do if chk_autoupdate.checked do update_quasiCrystals()
				on ddl_obj_type selected val do if chk_autoupdate.checked do update_quasiCrystals()
				on edt_eval entered val do if chk_autoupdate.checked do update_quasiCrystals()
				--on clr_wire_color changed val do if chk_autoupdate.checked do update_quasiCrystals()
				
				on btn_save_config pressed do
				(
					local cfg_file = getSaveFileName caption:"Save configuration file" types:"Configuration files(*.ini)|*.ini" filename:cfgdir
					
					if cfg_file!=undefined do
					(
						slib.csetting.save cfg_file "General" "iterations" spn_iterations.value
						slib.csetting.save cfg_file "General" "obj_type" ddl_obj_type.selection
						slib.csetting.save cfg_file "General" "random_color" chk_random_color.checked
						slib.csetting.save cfg_file "General" "autoupdate" chk_autoupdate.checked
						slib.csetting.save cfg_file "General" "eval" (getParsedEval())
						slib.csetting.save cfg_file "General" "obj_size" spn_obj_size.value
						slib.csetting.save cfg_file "General" "obj_quality" spn_obj_quality.value
							
						slib.csetting.save cfg_file "General" "vars" (getVarsSave())
					)
				)
				on btn_load_config pressed do
				(
					local cfg_file = getOpenFileName caption:"Load configuration file" types:"Configuration files(*.ini)|*.ini" filename:cfgdir
					
					if cfg_file!=undefined do
					(
						spn_iterations.value=slib.csetting.load cfg_file "General" "iterations" 377
						ddl_obj_type.selection=slib.csetting.load cfg_file "General" "obj_type" 1
						chk_random_color.checked=slib.csetting.load cfg_file "General" "random_color" false
						chk_autoupdate.checked=slib.csetting.load cfg_file "General" "autoupdate" false
						edt_eval.text=getReParsedEval (slib.csetting.loadStr cfg_file "General" "eval" "")
						spn_obj_size.value=slib.csetting.load cfg_file "General" "obj_size" 20
						spn_obj_quality.value=slib.csetting.load cfg_file "General" "obj_quality" 3
						
						lbx_vars.items = slib.sarray.getarray (slib.csetting.loadStr cfg_file "General" "vars" "") ";" 0
						
						if chk_autoupdate.checked do update_quasiCrystals()
					)
				)
			)

