--include "santex_fnlib.ms"

--slib.workDlg.open()
--slib.workDlg.job "Working ..."
-- returns a reversed copy of an array
fn ReverseArray arr =
(
	for i=arr.count to 1 by -1 collect arr[i]
)
fn getThisObject rule rule_num=
(
	local str = "undo off (\n local _this="
	if(rule.obj_type==1 OR rule.obj_type==6) do str+="Point size:(abs ("+(rule.size)+")) centermarker:false cross:true axistripod:false axisLength:(abs ("+(rule.size)+"))\n"
	if(rule.obj_type==2) do str+="geosphere radius:((abs ("+(rule.size)+"))/2) segs:4\n"
	if(rule.obj_type==3) do str+="box length:(abs ("+(rule.size)+")) width:(abs ("+(rule.size)+")) height:(abs ("+(rule.size)+"))\n centerPivot _this\n_this.pos=[0,0,0]\n"
	if(rule.obj_type==4) do str+="teapot radius:((abs ("+(rule.size)+"))/2) segs:4()\n"
	if(rule.obj_type==5) do str+="pyramid depth:(abs ("+(rule.size)+")) width:(abs ("+(rule.size)+")) height:((abs ("+(rule.size)+"))/1.618)\n"
	if(rule.obj_type==6) do str+="try(instanceReplace _this (all_rules["+rule_num as string+"].obj_inst))catch()\n"
	--instanceReplace $foo* $baz
	
	/*str += "color_end="+(rule.color_end as string)+"\n"
	str += "color_start="+(rule.color_start as string)+"\n"
	str += "cr=((color_end.r-color_start.r)/_it)\n"
	str += "cg=((color_end.g-color_start.g)/_it)\n"
	str += "cb=((color_end.b-color_start.b)/_it)\n"
	
	str += "cr=(color_start.r+cr)*_i\n"
	str += "cg=(color_start.g+cg)*_i\n"
	str += "cb=(color_start.b+cb)*_i\n"
	str += "ccolor=(color cr cg cb)\n"
	str += "nc=color_start\n"
	str += "nc.h=((color_end.h-color_start.h)*_i)"*/
	str +=( "_this.wirecolor="+(rule.color_start as string)+")\n")
	
	return str
)

fn evaluateCode=
(
-- build code and execute it
local eval_code = ""

-- create global variables part
for i=1 to all_vars.count do
(
	local var = all_vars[i]
	local var_code = ("global " + var.name + "=" + var.value as string)
	eval_code += (var_code + "\n")
)
eval_code += "\n"

-- create main function
--eval_code += "struct quasiCrystals3MainFn (\n\n"

-- create code body
for i=all_rules.count to 1 by -1 do
(
	--if(all_rules[i].enabled) do
	--(
	
	-- create rule function
	eval_code += "fn quasiCrystals3Rule"+(i as string)+"=(\n"
	-- define _this and create object for each rule
	
	local rule = all_rules[i]
	eval_code += (rule.preeval + "\n")
	eval_code += ("local _this_objs=#()\n")
	local rule_code = ("for _i=1 to (" + (rule.iterations) + ") do\n(\n")
	rule_code += ("local _it=(" + (rule.iterations) + ")\n");   -- pseudovar '_it' defined
	rule_code += getThisObject (all_rules[i]) i   -- pseudovar '_this' defined
	rule_code += ("append all_objects _this\n")
	rule_code += ("append _this_objs _this\n")
	rule_code += (rule.eval + "\n)\n")
	eval_code += (rule_code + "\n")
	
	--if (i==all_rules.count) then eval_code += ("return true\n)--END rule\n")
	--else eval_code += ("return true\n),--END rule\n")
	eval_code += ("return _this_objs\n)\n\n")
	
	--) end if
)

-- create exec section
/*
eval_code += "fn exec=(\n"
for i=1 to all_rules.count do
(
eval_code += "rule = quasiCrystals3Rule"+(i as string)+"()\n"	
)
eval_code += ")\n\n"
*/
--eval_code += ")\n\n"

-- create run section
--eval_code += "global _eval_code = quasiCrystals3MainFn()\n"
--eval_code += "_eval_code.exec()\n"
for i=1 to all_rules.count do
(
	if(all_rules[i].enabled) do
	(
		eval_code += "_eval_code = quasiCrystals3Rule"+(i as string)+"()\n"	
	)
)

return eval_code

)
print_report = timeStamp()

if (quasiCrystals3.chk_dev_post.checked) do(clearListener(); print (evaluateCode()))
execute(evaluateCode())
completeRedraw()
clearUndoBuffer()
	
print_report1 = timeStamp()

if (quasiCrystals3.chk_time_post.checked) do print ("(quasiCrystals3): " + ((print_report1 - print_report)) as string + " ms")

--slib.workDlg.close()