global quasiCrystals3_import

rollout quasiCrystals3_import "quasiCrystals3 - Import from config file" width:360 height:250
(
	local imp_all_vars = #()
	local imp_all_rules = #()
	/*struct var_struct
	(
		name="",
		type=1,
		value=""
	)
	struct rule_struct
	(
		name=" ",
		enabled=true,
		iterations=" ",
		parent=" ",
		nth=" ",
		obj_type=1,
		obj_inst,
		size=" ",
		preeval=" ",
		eval=" ",
		color_start=(color 160 190 50),
		color_end=(color 160 190 50)
	)*/
	
	multilistbox lbx_vars "Global variables:" height:10 width:120
	multilistbox lbx_rules "Rules:" height:10 width:180 pos:[150,5]
	
	button btn_clr_vars "X" pos:[12,170] tooltip:"Clear variables selection"
	button btn_clr_rules "X" pos:[150,170] tooltip:"Clear rules selection"
	
	button btn_import_sel "Import selected" width:120 height:32 align:#right
	
	include "santex_fnlib.ms"
	
	fn refreshVarsList=
	(
		local temp=#()
		lbx_vars.items=#()
		for i=1 to imp_all_vars.count do
		(
			append temp (imp_all_vars[i].name+" = "+imp_all_vars[i].value as string )
		)
		lbx_vars.items=temp
		
	)
	fn refreshRulesList=
	(
		local temp=#()
		lbx_rules.items=#()
		for i=1 to imp_all_rules.count do
		(
			if (NOT imp_all_rules[i].enabled) then _e=("<disabled>: ") else _e=(i as string + ": ")
			append temp ( _e + imp_all_rules[i].name + " [ "+imp_all_rules[i].iterations + " ]")
		)
		lbx_rules.items=temp
		
		--if(quasiCrystals3.chk_autoupdate.checked) do quasiCrystals3.evalCode()
	)
	fn getVarsLoad vars=
	(
		local arr1 = filterstring vars ";"
		local temp = #()
		for i=1 to arr1.count do
		(
			local arr2 = filterstring arr1[i] "@"
			local new_var = var_struct name:(arr2[1] as string) type:(arr2[2] as integer) value:(arr2[3] as string)
			append temp new_var
		)
		return temp
	)
	fn getReParsedEval str=
	(
		local parsed = ""
		for i=1 to str.count do
		(
			if (str[i]==";") then parsed += "\n"
			else parsed += str[i]
		)
		
		if(parsed==undefined OR parsed=="") do parsed=" "
		return parsed
	)
	fn getRulesLoad vars=
	(
		local arr1 = filterstring vars "|"
		local temp = #()
		for i=1 to arr1.count do
		(
			local arr2 = filterstring arr1[i] "@"
			local new_rule = rule_struct()
			new_rule.name = arr2[1] as string
			new_rule.enabled = arr2[2] as booleanClass
			new_rule.iterations = arr2[3] as string
			
			new_rule.parent = arr2[4] as string
			new_rule.nth = arr2[5] as string
			new_rule.obj_type = arr2[6] as integer
			--new_rule.obj_inst = arr2[7] as string
			
			try(i_o = execute("$"+arr2[7] as string +"*"))catch()
				print i_o
			--if (i_o!=undefined) do new_rule.obj_inst = execute("$"+arr2[7] as string +"*")
			
			
			new_rule.size = arr2[8] as string
			
			new_rule_preeval = getReParsedEval (arr2[9] as string)
			new_rule_eval = getReParsedEval (arr2[10] as string)
			
			new_rule.preeval = new_rule_preeval as string
			new_rule.eval = new_rule_eval as string
			
			new_rule.color_start = execute(arr2[11] as string)
			new_rule.color_end = execute(arr2[12] as string)
			
			append temp new_rule
		)
		return temp
	)
	
	on btn_clr_vars pressed do
	(
		lbx_vars.selection = 0
	)
	on btn_clr_rules pressed do
	(
		lbx_rules.selection = 0
	)
	
	on btn_import_sel pressed do
	(
		local tmp = #()
		for i=1 to lbx_vars.selection.count do
		(
			if (lbx_vars.selection[i] == true) do append tmp imp_all_vars[i]
		)			
		join all_vars tmp
		
		tmp = #()
		for i=1 to lbx_rules.selection.count do
		(
			if (lbx_rules.selection[i] == true) do append tmp imp_all_rules[i]
		)			
		join all_rules tmp
		
		destroydialog quasiCrystals3_import
		
		quasiCrystals3.refreshVarsList()
		quasiCrystals3.refreshRulesList()
	)
	
	on quasiCrystals3_import open do
	(
		local cfgdir=((getdir #maxroot)+"plugcfg\\santexTools\\quasiCrystals3\\")
		local cfg_file = getOpenFileName caption:"Load configuration file" types:"Configuration files(*.ini)|*.ini" filename:cfgdir
		
		if cfg_file!=undefined then
		(
			imp_all_vars = getVarsLoad (slib.csetting.loadStr cfg_file "General" "vars" "")
			imp_all_rules = getRulesLoad (slib.csetting.loadStr cfg_file "General" "rules" "")
			
			refreshVarsList()
			refreshRulesList()
			
			--lbx_vars.selection = #{}
			--lbx_rules.selection = #{}
			
		)else
		(
			try(destroydialog quasiCrystals3_import)catch()
		)
		
		
		/*local cfg_file = getOpenFileName caption:"Load configuration file" types:"Configuration files(*.ini)|*.ini" filename:cfgdir
		
		if cfg_file!=undefined do
		(
			spn_seed.value=slib.csetting.load cfg_file "General" "seed" 1
			chk_autoupdate.checked=slib.csetting.load cfg_file "General" "autoupdate" false
			
			all_vars = getVarsLoad (slib.csetting.loadStr cfg_file "General" "vars" "")
			
			refreshVarsList()
			lbx_vars.selection = lbx_vars.items.count
			refreshVarUI()
			
			all_rules = getRulesLoad (slib.csetting.loadStr cfg_file "General" "rules" "")
			refreshRulesList()
			lbx_rules.selection = lbx_rules.items.count
		)*/
	)
)
createdialog quasiCrystals3_import