global quasiCrystals4

struct qC4_struct
(
	all_objects=#(),
	all_vars=#(),
	all_rules=#()
)
global stx=qC4_struct()

rollout quasiCrystals4 "quasiCrystals4 - 3D pattern analyzer" width:248 height:370
(
	local maintitle="quasiCrystals4"
	local copyright="(c)2013 by santex"
	local cfgdir=((getdir #maxroot)+"plugcfg\\santexTools\\quasiCrystals4\\")
	local configfile=(((getdir #maxroot)+"plugcfg\\santexTools\\quasiCrystals4\\")+"quasiCrystals4.ini")
	local devlogfile=(((getdir #maxroot)+"plugcfg\\santexTools\\quasiCrystals4\\")+"quasiCrystals4.log")
	
	struct var_struct
	(
		name="",
		type=1,
		value=""  -- always string, because it is always expression
	)
	
	struct rule_struct
	(
		name="",
		desc="",
		enabled=true,
		iterations="",	-- string, expression
		parent="",
		condition="",	-- specify when this rule is executed ... TODO - syntax
		obj_type=1,
		obj_inst,
		obj_inst_name="",
		size="",
		preeval="",		-- local (rule) vars
		eval="",
		move="",
		scale="",
		rotate="",
		obj_color=(color 160 190 50),
		start_pos=1	-- radiobuttons to choose: 1-inherit from parent 2-absolute, 3-custom?
	)
	
	global obj_types = #("Point","GeoSphere","Box","Teapot","Pyramid","Instanced ...")
	local var_types = #("Integer","Float","Boolean","Random","Expr.","Const.","Special")
	local var_constants = #("Pi(3.14)","Phi(1.618)","e(2.718)","4.669")
	local var_constants_val = #("3.141592654", "1.618033989", "2.71828","4.669201609")
	
	local dev_print_post = true
	
	listbox lbx_vars "Global variables:" height:8 width:120
	radiobuttons rbt_var_type "Type:" labels:var_types default:1 columns:1 pos:[160,8]
	button btn_var_up "/\\" pos:[134,23] width:18 height:40 tooltip:"Move selected variable up"
	button btn_var_down "\/" pos:[134,64] width:18 height:40 tooltip:"Move selected variable down"
	button btn_var_del "X" pos:[134,104] width:18 height:30 tooltip:"Delete selected variable"
	
	edittext edt_var_name "Name:" pos:[8,146] width:180
	button btn_var_add ">" tooltip:"Add new variable" pos:[190,146] height:18

	spinner spn_var_int "Integer value:" type:#integer range:[spinner_min,spinner_max,0] visible:true pos:[8,176]
	spinner spn_var_float "Float value:" type:#float range:[spinner_min,spinner_max,0] visible:false pos:[8,176]
	radiobuttons rbt_var_bool "Boolean value:" labels:#("false","true") default:1 columns:2 visible:false pos:[8,176]
	
	spinner spn_var_random_min "Random value (min):" type:#float range:[spinner_min,spinner_max,0] visible:false pos:[8,176]
	spinner spn_var_random_max "(max):" type:#float range:[spinner_min,spinner_max,0] visible:false pos:[75,196]
	
	edittext edt_var_expr "Expression:" visible:false pos:[8,176] height:40
	radiobuttons rbt_var_const "" labels:var_constants default:1 columns:3 visible:false pos:[8,176]
	button btn_var_special "Open special variable options ..." visible:false pos:[8,176] width:206
	
	include "santex_fnlib.ms"
	
	on quasiCrystals4 open do
	(
		slib.file.init configfile "config"
	)
	
	on quasiCrystals4 close do
	(
		
	)
)