


global all_projects = #()
global open_project = ""
global subRollout_projects

struct project_struct
(
	dir,
	name,
	script
)


fn getProjectsList prop=
(
	local temp_arr = #()
	for i=1 to all_projects.count do
	(
		if prop == "names" then
		(
			append temp_arr (all_projects[i].name)
		)
		if prop == "dirs" then
		(
			append temp_arr (all_projects[i].dir)
		)
	)
	return temp_arr
)


fn loadProjects=
(
	local dirs=getDirectories ("$scripts\\santexSandbox1\\*")
	--local project_dirs=#()
	
	for i=1 to dirs.count do
	(
		local temp_dir = filterString dirs[i] "\\"
		local temp_name = temp_dir[temp_dir.count]
		local temp_script = (dirs[i]+ "\\" + temp_name + ".ms")
		
		local new_project = project_struct dir:dirs[i] name:temp_name script:temp_script
		
		if (doesFileExist temp_script) then append all_projects new_project
	)
	
	subRollout_projects.lbx_projects.items = getProjectsList("names")
)







rollout subRollout_projects "subRollout_projects"
(
	fn localizeStrings=
	(
		subRollout_projects.title=strings.projects
		subRollout_projects.btn_select_project.text=strings.btn_select_project
		subRollout_projects.btn_close_project.text=strings.btn_close_project
		
		subRollout_projects.btn_select_project.tooltip=strings.strings_tt.btn_select_project
		subRollout_projects.btn_close_project.tooltip=strings.strings_tt.btn_close_project
		
	)
	listbox lbx_projects "" height:8
	button btn_select_project "btn_select_project" width:100 pos:[6,122]
	button btn_close_project "btn_close_project" width:100 pos:[108,122]
	
	include "santex_fnlib.ms"
	
	on subRollout_projects open do
	(		
		localizeStrings()
		loadProjects()
	)
	
	on lbx_projects doubleclicked sel do
	(
		if(NOT (slib.setting.load "chk_run_outside" false))then
		(
			if (open_project != (all_projects[lbx_projects.selection].name)) then
			(
				slib.workDlg.open()
				slib.workDlg.job strings.system.loadScript
				
				mUI_delSubRollout (execute(open_project))
				
				gc()
					
				local selected_project = (all_projects[lbx_projects.selection].dir + "\\" + all_projects[lbx_projects.selection].name + ".ms")
				open_project = all_projects[lbx_projects.selection].name
				fileIn selected_project
					
				mUI_addSubRollout (execute(open_project))
					
				slib.workDlg.close()
			)
		)else
		(
			local selected_project = (all_projects[lbx_projects.selection].dir + "\\" + all_projects[lbx_projects.selection].name + ".ms")
			--open_project = all_projects[lbx_projects.selection].name
			fileIn selected_project
			execute ("createdialog "+all_projects[lbx_projects.selection].name)
			
			if(slib.setting.load "chk_close" false)do (destroydialog santexSandbox1)
		)
	)
	on btn_select_project pressed do
	(
		if(NOT (slib.setting.load "chk_run_outside" false))then
		(
			if (open_project != (all_projects[lbx_projects.selection].name)) then
			(
				slib.workDlg.open()
				slib.workDlg.job strings.system.loadScript
				
				mUI_delSubRollout (execute(open_project))
				
				gc()
					
				local selected_project = (all_projects[lbx_projects.selection].dir + "\\" + all_projects[lbx_projects.selection].name + ".ms")
				open_project = all_projects[lbx_projects.selection].name
				fileIn selected_project
					
				mUI_addSubRollout (execute(open_project))
					
				slib.workDlg.close()
			)
		)else
		(
			local selected_project = (all_projects[lbx_projects.selection].dir + "\\" + all_projects[lbx_projects.selection].name + ".ms")
			--open_project = all_projects[lbx_projects.selection].name
			fileIn selected_project
			execute ("createdialog "+all_projects[lbx_projects.selection].name)
			
			if(slib.setting.load "chk_close" false)do (destroydialog santexSandbox1)
		)
	)
	on btn_close_project pressed do
	(
		slib.workDlg.open()
		slib.workDlg.job strings.system.close
		
		if ( mUI_delSubRollout (execute(open_project)) ) then open_project = ""
			
		slib.workDlg.close()	
	)
)





global santexSandbox1

rollout santexSandbox1 "santexSandbox (v1.0)"
(
	fn localizeStrings=
	(
		santexSandbox1.btn_view2d3d.text=strings.btn_view2d3d
		santexSandbox1.btn_settings.text=strings.btn_settings
		santexSandbox1.btn_exit.text=strings.btn_exit
		
		santexSandbox1.btn_view2d3d.tooltip=strings.strings_tt.btn_view2d3d
		santexSandbox1.btn_settings.tooltip=strings.strings_tt.btn_settings
		santexSandbox1.btn_exit.tooltip=strings.strings_tt.btn_exit
	)
	subRollout subRollouts "" pos:[8,8] width:232 height:1000
	checkbutton btn_view2d3d "btn_view2d3d" width:24 enabled:false
	button btn_settings "btn_settings" width:24
	button btn_exit "btn_exit" width:24
	include "santex_fnlib.ms"
	
	on santexSandbox1 open do
	(
		localizeStrings()
		
		slib.workDlg.open()
		slib.workDlg.job strings.system.init
		
		if ((heapSize as integer)<memory_allocation) then
		(
			heapSize += (memory_allocation-(heapSize as integer))
			gc()
		)
		
		slib.file.init configfile "ConfigFile"
		slib.dlg.setPos santexSandbox1 (slib.setting.load "santexSandbox1.pos" ([0,0]))
		slib.workDlg.job strings.system.init
		slib.dlg.setSize santexSandbox1 (slib.setting.load "santexSandbox1.size" (getDialogSize santexSandbox1))
		slib.workDlg.job strings.system.init
			
		--resetview_2d()
			
		gc()
		clearListener()
			
		slib.workDlg.close()
	)
	
	on santexSandbox1 close do
	(		
		try(destroydialog santexSandbox1_settings)catch()
		
		slib.workDlg.open()
		slib.workDlg.job strings.system.close
		
		filein "$scripts\\santexSandbox1\\vars.ms"
		
		slib.setting.save "santexSandbox1.pos" (getDialogPos santexSandbox1)
		slib.setting.save "santexSandbox1.size" (getDialogSize santexSandbox1)
		
		clearAllVars()
		gc()
		
		slib.workDlg.close()
		
		--viewport.ResetAllViews()
	)
	
	on santexSandbox1 resized newsize do
	(
		newsize.x=248
		subRollouts.height=(newsize.y-45)
		btn_settings.pos=[210-32,(newsize.y-28)]
		btn_view2d3d.pos=[8,(newsize.y-28)]
		btn_exit.pos=[210,(newsize.y-28)]
		--santexSandbox1.width=newsize.x
	)
	
	on btn_view2d3d changed state do
	(
		--printlog type:5 txt:("plasmacutter_ui.ms -> on btn_view2d3d changed "+state as string)
		
		if (state) then resetview_3d() else resetview_2d()
	)
	
	on btn_exit pressed do
	(
		--cui.UnRegisterDialogBar santexSandbox1
		destroydialog santexSandbox1
	)
	
	on btn_settings pressed do
	(
		filein "$scripts\\santexSandbox1\\settings.ms"
	)
)






CreateDialog santexSandbox1 style:#(#style_border,#style_titlebar,#style_resizing,#style_sysmenu,#style_minimizebox)
addSubRollout santexSandbox1.subRollouts subRollout_projects rolledUp:false

--cui.RegisterDialogBar santexSandbox1 style:#(#cui_dock_left,#cui_floatable)
--cui.DockDialogBar santexSandbox1 #cui_dock_left