global santexToolbox_create
current_vars=#()
rcmenu menu_vars
(
	menuItem mi_on "Enabled" checked:true enabled:true
	separator sep0 ""
	menuitem mi_edit "Edit" enabled:false
	menuitem mi_add "Add" enabled:false
	menuitem mi_dupl "Duplicate" enabled:true
	menuitem mi_del "Delete"
	separator sep1 ""
	menuItem mi_none "<None>"-- checked:true
	menuItem mi_edt "Edittext (Expression)"
	menuItem mi_integer "Spinner (Integer)"
	menuItem mi_float "Spinner (Float)"
	menuItem mi_pick "Pickbutton (<Node>)"
	menuItem mi_bool "Checkbox (Boolean)"
	menuItem mi_custom "<User specified>"
	
	on mi_on picked do
	(
		current_vars[santexToolbox_create.lbx_vars.selection].use = NOT mi_on.checked
		santexToolbox_create.refresh_var_list()
	)
	
	on mi_edit picked do
	(
		try(destroydialog santexToolbox_add_var)catch(); filein "santexToolbox_edit_var.ms"
	)
	on mi_add picked do
	(
		try(destroydialog santexToolbox_add_var)catch(); filein "santexToolbox_add_var.ms" 
	)
	on mi_dupl picked do
	(
		try(destroydialog santexToolbox_add_var)catch()
		
		--local new_var = copy all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].vars[santexToolbox_create.lbx_vars.selection]
		local new_var = copy current_vars[santexToolbox_create.lbx_vars.selection]
		new_var.name = new_var.name+"_cpy"
		santexToolbox_create.add_new_var new_var
	)	
	on mi_del picked do
	(
		if(querybox "Do you really want to delete selected parameter?" title:"santexToolbox")do
		(
			deleteItem current_vars (santexToolbox_create.lbx_vars.selection)
			santexToolbox_create.refresh_var_list()
		)
	)
	
	on mi_none picked do
	(
		current_vars[santexToolbox_create.lbx_vars.selection].handler = 1
	)
	on mi_edt picked do
	(
		current_vars[santexToolbox_create.lbx_vars.selection].handler = 2
	)
	on mi_integer picked do
	(
		current_vars[santexToolbox_create.lbx_vars.selection].handler = 3
	)
	on mi_float picked do
	(
		current_vars[santexToolbox_create.lbx_vars.selection].handler = 4
	)
	on mi_pick picked do
	(
		current_vars[santexToolbox_create.lbx_vars.selection].handler = 5
	)
	on mi_bool picked do
	(
		current_vars[santexToolbox_create.lbx_vars.selection].handler = 6
	)
	on mi_custom picked do
	(
		current_vars[santexToolbox_create.lbx_vars.selection].handler = 7
	)
	
	on menu_vars open do
	(
		local ui_items = #(mi_on,mi_edit,mi_add,mi_dupl,mi_del,mi_none,mi_edt,mi_integer,mi_float,mi_pick,mi_bool,mi_custom)
		
		if(current_vars.count!=0 AND santexToolbox_create.lbx_vars.selection!=0)then
		(
			local curr_var = current_vars[santexToolbox_create.lbx_vars.selection]
			
			for i=1 to ui_items.count do ui_items[i].checked = false
			ui_items[curr_var.handler+5].checked = true
			mi_on.checked = curr_var.use as booleanClass
			
			for i=1 to ui_items.count do ui_items[i].enabled = true
			--mi_on.enabled = mi_edit.enabled = mi_dupl.enabled = false
			mi_edit.enabled = false
		)else
		(
			for i=1 to ui_items.count do ui_items[i].enabled = false
			--mi_add.enabled = true
		)
	)
)
rollout santexToolbox_create  "santexToolbox - Create new tool" width:380 height:280
(
	local ui_min_size=[380,280]
	--local for_items=#("Selection <array of nodes>",
		--					"Selection <single node>",
			--				"Copies from selection <single node>",
				--			"Instancies from selection <single node>",
					--		"<User specified>") -- dont forget to change also in santexToolbox_eval.ms (around line: 43)
	local for_items = santexToolbox_ui_for_items
	local more_options=tool_options_struct()
	local adv_setts=adv_setts_struct()
	--global include_tools=#()
	local cfgdir=((getdir #maxroot)+"plugcfg\\santexTools\\santexToolbox\\")
	
	edittext edt_name "* Tool name:" width:550
	edittext edt_id "* ID:  _tool_" width:550 tooltip:"Use only alphanumeric characters without spaces"
	edittext edt_desc "Description:" width:550 height:48 pos:[8,28]
	
		dropdownlist ddl_for "* Apply tool for (mode):" items:for_items width:500 height:(for_items.count + 1) 
		label lbl1 ""
		label lbl2 ""
 button btn_help "?" tooltip:"Show quick help" width:18 height:18 pos:[184,134]
	button btn_include "Include tools" tooltip:"Define which tools should be compiled before this tool's code" enabled:true width:150 height:18 pos:[12,134] visible:false
	
	listbox lbx_vars "" height:8 width:150
	button btn_vars_add "Add" width:48 tooltip:"Add new parameter" enabled:false visible:false
	button btn_vars_edit "Edit" width:48 tooltip:"Edit selected parameter (not available when creating new tool)" enabled:false visible:false
	button btn_vars_up "/\\" width:28 height:16 tooltip:"Move selected parameter up in the list" enabled:false visible:false
	button btn_vars_down "\/" width:28 height:16 tooltip:"Move selected parameter down in the list" enabled:false visible:false
	button btn_vars_del "X" width:28 tooltip:"Delete selected parameter" enabled:false	 visible:false
		--edittext edt_vars "Constants:" width:550 height:60
		edittext edt_eval "" width:450 height:240
							
	button btn_options "..." width:50 height:24 tooltip:"More options (not available when creating new tool)" enabled:false visible:false
	
	button btn_ok "CREATE" width:120 height:32
	button btn_cancel "Cancel" width:80 height:32
	
	button btn_adv "..." width:40 height:32 tooltip:"Advanced options (not available when creating new tool)" enabled:false visible:false
	
	
	
	include "santex_fnlib.ms"
	
	fn getOptionsSave new_tool_options=
	(
		--local temp=""
		--print new_tool.apply_options
		--local more_options = new_tool.apply_options
		local tempstr = (new_tool_options.num as string+ "@" +\
						new_tool_options.rand_scale as string + "@" +\
						new_tool_options.rand_scale_min as string + "@" +\
						new_tool_options.rand_scale_max as string)
		return tempstr
	)
	/*fn saveMoreOptions=
	(
		local filename = cfgdir + (all_toolsets[santexToolbox.lbx_tools.selection].dir) +"\\"+new_tool.id+ ".ini"
		slib.csetting.save filename "Options" "num" (new_tool.apply_options.num)
		slib.csetting.save filename "Options" "rand_scale" (new_tool.apply_options.rand_scale)
		slib.csetting.save filename "Options" "rand_scale_min" (new_tool.apply_options.rand_scale_min)
		slib.csetting.save filename "Options" "rand_scale_max" (new_tool.apply_options.rand_scale_max)
	)*/
	fn getAdvSettsSave new_tool_advsetts=
	(
		local tempstr = (new_tool_advsetts.internal as string)
		return tempstr
	)
	fn getParsedEval etext=
	(
		local parsed = ""
		for i=1 to etext.count do
		(
			if (etext[i]=="\n") then parsed += ";"
			else parsed += etext[i]
		)
		
		if(parsed==undefined OR parsed=="") do parsed=" "
		return parsed
	)
	fn getVarsSave=
	(
		local temp = ""
		--local current_vars = all_toolsets[ddl_toolset.selection].tools[lbx_tools.selection].vars
		for i=1 to current_vars.count do
		(
			local var = (current_vars[i].caption + "~" +\
							current_vars[i].name + "~" +\
							current_vars[i].type as string + "~" +\
							current_vars[i].handler as string + "~" +\
							(getParsedEval(current_vars[i].value as string)) + "~" +\
							current_vars[i].use as string + "~" +\
							(getParsedEval(current_vars[i].custom_handler)))
			temp += (var + "|")
		)
		return temp
	)
	
	fn store_new_tool_file new_tool=
	(
		local filename = cfgdir + (all_toolsets[santexToolbox.ddl_toolset.selection].dir) +"\\"+new_tool.id+ ".ini"
		slib.file.init filename "Tool"
		
		local tool_eval = (getParsedEval (new_tool.code))
		
		slib.csetting.save filename "General" "name" (new_tool.name)
		slib.csetting.save filename "General" "id" (new_tool.id)
		slib.csetting.save filename "General" "desc" (new_tool.desc)
		slib.csetting.save filename "General" "apply_for" (new_tool.apply_for)
		slib.csetting.save filename "General" "code" (tool_eval)
		slib.csetting.save filename "General" "vars" (getVarsSave())
			
		--saveMoreOptions()
		slib.csetting.save filename "Options" "num" (new_tool.apply_options.num)
		slib.csetting.save filename "Options" "rand_scale" (new_tool.apply_options.rand_scale)
		slib.csetting.save filename "Options" "rand_scale_min" (new_tool.apply_options.rand_scale_min)
		slib.csetting.save filename "Options" "rand_scale_max" (new_tool.apply_options.rand_scale_max)
		
			--slib.csetting.save filename "General" "options" (getOptionsSave new_tool.apply_options)
		slib.csetting.save filename "Settings" "internal" (new_tool.adv_setts.internal)
			slib.csetting.save filename "Settings" "hide_ctrl" (new_tool.adv_setts.hide_ctrl)
	)
	/*
	fn refresh_var_list_ui=
	(
		if(lbx_vars.selection!=0)then
		(
			--btn_vars_edit.enabled = btn_vars_del.enabled = true
			btn_vars_del.enabled = true
		)else
		(
			--btn_vars_edit.enabled = btn_vars_del.enabled = false
			btn_vars_del.enabled = false
		)
	)
	fn refresh_var_list=
	(
		local temparr=#()
		for i=1 to current_vars.count do
		(
			append temparr (current_vars[i].name+" = "+current_vars[i].value as string)
		)
		lbx_vars.items=temparr
		refresh_var_list_ui()
	)*/
	
	
	fn refresh_var_list_ui=
	(
		if(lbx_vars.selection!=0)then
		(
			btn_vars_up.enabled = btn_vars_down.enabled = btn_vars_del.enabled = true
			--btn_vars_edit.enabled = btn_vars_del.enabled = btn_vars_up.enabled = btn_vars_down.enabled = true
		)else
		(
			btn_vars_up.enabled = btn_vars_down.enabled = btn_vars_del.enabled = false
			--btn_vars_edit.enabled = btn_vars_del.enabled = btn_vars_up.enabled = btn_vars_down.enabled = false
		)
	)
	fn refresh_var_list=
	(
		local temparr=#()
		--current_vars = #()
		for i=1 to current_vars.count do
		(
			if(current_vars[i].use=="false" OR\
				current_vars[i].use==false)then
			(
				append temparr (" ! "+current_vars[i].name+" = "+current_vars[i].value as string)
			)else
			(
				append temparr (current_vars[i].name+" = "+current_vars[i].value as string)
			)
			--append current_vars (all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].vars[i])
		)
		lbx_vars.items=temparr
		refresh_var_list_ui()
	)
	
	
	fn add_new_var var=
	(
		append current_vars var
		refresh_var_list()
	)
	
	fn resizeUI new_size=
	(
		ui_max_size=[(systemTools.GetScreenWidth() - 10),(systemTools.GetScreenHeight() - 100)]
		dlg_size=slib.dlg.resizelim santexToolbox_create new_size ui_min_size ui_max_size
		edt_name.width=(dlg_size.x-140)/2
		edt_desc.width=dlg_size.x-96
		ddl_for.width=dlg_size.x-100
		lbx_vars.height=(dlg_size.y-254)
		--edt_vars.width=dlg_size.x-70-14
		--edt_vars.height=((dlg_size.y-200)/3)
		edt_eval.pos.y=lbx_vars.pos.y
		edt_eval.pos.x=184
		edt_eval.width=dlg_size.x-210
		edt_eval.height=dlg_size.y-220
		
		btn_cancel.pos.y=dlg_size.y-45
		btn_ok.pos.y=dlg_size.y-45
		btn_cancel.pos.x=dlg_size.x-100
		btn_ok.pos.x=dlg_size.x-100-100-30
		btn_adv.pos.x=dlg_size.x-100-100-30-50
		btn_adv.pos.y=dlg_size.y-45
		
		btn_options.pos=[(dlg_size.x-78),98]
		btn_vars_add.pos=[16,dlg_size.y-85]
		btn_vars_edit.pos=[16+45,dlg_size.y-85]
		btn_vars_del.pos=[135,dlg_size.y-85]
		btn_vars_up.pos=[16+45+45,dlg_size.y-85-3]
		btn_vars_down.pos=[16+45+45,dlg_size.y-85+13]
		
		edt_id.width=(dlg_size.x-edt_name.width-177)
		edt_id.pos=[(edt_name.width+150),5]
	)
	fn create_new_tool=
	(
		if(edt_name.text!="" AND edt_id.text!="")then
		(
			local more_options=tool_options_struct()
			local edt_desc_text = getParsedEval edt_desc.text
			--adv_setts = all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].adv_setts
			local new_tool=tool_struct name:edt_name.text\
												id:edt_id.text\
												desc:edt_desc_text\
												apply_for:ddl_for.selection\
												code:edt_eval.text\
												vars:current_vars\
												apply_options:more_options\
												include_tools:include_tools
				
			destroydialog santexToolbox_create
			santexToolbox.add_new_tool new_tool
			store_new_tool_file new_tool
		)else messagebox "Enter Tool name and ID!" title:"Error"
	)
	fn moveVar dir=
	(
		if (dir=="up") do dir=-1
		if (dir=="down") do dir=1
		if (lbx_vars.selection!=0 AND \
			(dir==-1 AND lbx_vars.selection!=1) OR \
			(dir==1 AND lbx_vars.selection!=lbx_vars.items.count)
		) do
		(
			local tempvar=current_vars[lbx_vars.selection]
			deleteItem current_vars lbx_vars.selection
			insertItem tempvar current_vars (lbx_vars.selection+dir)
			
			refresh_var_list()
			lbx_vars.selection = (lbx_vars.selection+dir)
			--refreshVarUI()
		)
	)
	
	on lbx_vars selected sel do
	(
		refresh_var_list_ui()
	)
	on lbx_vars rightClick do
	(
		--if(santexToolbox.lbx_tools.selection>0)do
			popUpMenu menu_vars
	)
	on ddl_for selected sel do
	(
		--btn_options.enabled=false
		
		--if (sel==4) do btn_options.enabled=true
	)
	on btn_vars_add pressed do ( try(destroydialog santexToolbox_add_var)catch(); filein "santexToolbox_add_var.ms" )
	on btn_vars_edit pressed do ( try(destroydialog santexToolbox_add_var)catch(); filein "santexToolbox_edit_var.ms" )
	on btn_vars_up pressed do moveVar "up"
	on btn_vars_down pressed do moveVar "down"
	on btn_vars_del pressed do
	(
		--try(destroydialog santexToolbox_add_var)catch(); filein "santexToolbox_add_var.ms"
		if(querybox "Do you really want to delete selected parameter?" title:"santexToolbox")do
		(
			--if(santexToolbox.lbx_tools.selection>0)do
			--(
			--local filename = cfgdir + (all_toolsets[santexToolbox.lbx_tools.selection].dir) +"\\"+all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].id+ ".ini"
			--deleteFile filename
			--)
			deleteItem current_vars (lbx_vars.selection)
			refresh_var_list()
		)
	)
	on btn_adv pressed do ( try(destroydialog santexToolbox_create_adv)catch(); filein "santexToolbox_create_adv.ms" )
	on btn_help pressed do ( try(destroydialog santexToolbox_quick_help)catch(); filein "santexToolbox_quick_help.ms" )
	on btn_include pressed do
	(
		try(destroydialog santexToolbox_include)catch()
		--include_tools=#()
		filein "santexToolbox_include.ms"
		--print include_tools
	)
	on btn_options pressed do ( try(destroydialog santexToolbox_more_options)catch(); filein "santexToolbox_more_options.ms" )
	on btn_ok pressed do
	(
		create_new_tool()
	)
	--on edt_name entered txt do create_new_tool()
	--on edt_id entered txt do create_new_tool()
	on btn_cancel pressed do
	(
		destroydialog santexToolbox_create
	)
	on santexToolbox_create close do
	(
		try(destroydialog santexToolbox_add_var)catch()
		try(destroydialog santexToolbox_create_adv)catch()
		try(destroydialog santexToolbox_quick_help)catch()
		try(destroydialog santexToolbox_more_options)catch()
		
		current_vars = #()
		
		slib.setting.save "santexToolbox_create.pos" (getDialogPos santexToolbox_create)
		slib.setting.save "santexToolbox_create.size" (getDialogSize santexToolbox_create)
	)
	on santexToolbox_create open do
	(
		current_vars = #()
		slib.dlg.setSize santexToolbox_create (slib.setting.load "santexToolbox_create.size" (getDialogSize santexToolbox_create))
		resizeUI (slib.dlg.getSize santexToolbox_create)
		slib.dlg.setPos santexToolbox_create (slib.setting.load "santexToolbox_create.pos" [0,0])
			
		setFocus santexToolbox_create.edt_name
			
		--slib.dlg.setSize santexToolbox_create (slib.setting.load "santexToolbox_create.size" (getDialogSize santexToolbox_create))
		--temp_tool = tool_struct name:"temp tool"
	)
	on santexToolbox_create resized new_size do	resizeUI new_size
)
createdialog santexToolbox_create style:#(#style_border,#style_titlebar,#style_resizing) modal:true