global santexToolbox_include

rollout santexToolbox_include "Include (pre-compile) selected tools" width:240 height:140
(
	local ui_min_size=[323,140]
	local all_tools_available = #()
	
	multilistbox lbx_all_tools "All available tools:" width:350 height:8
	button btn_ok "INCLUDE" width:120 height:32
	button btn_cancel "Cancel" width:80 height:32
	button btn_none "X" width:32 height:32 tooltip:"Clear selection"
	
	include "santex_fnlib.ms"
	
	fn refresh_all_tools_list=
	(
		local temparr = #()
		--local all_toolsets_copy = deepcopy all_toolsets
		if(all_toolsets.count>0)do
		(
			for i=1 to all_toolsets.count do
			(
				if(all_toolsets[i].tools.count>0)do
				(
					for j=1 to all_toolsets[i].tools.count do
					(
						if(all_toolsets[i].tools[j].id!=all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].id)do
						(
							append temparr (all_toolsets[i].name +" ("+all_toolsets[i].author+")  --->   "+ all_toolsets[i].tools[j].name +" (_tool_"+all_toolsets[i].tools[j].id+")")
							append all_tools_available (all_toolsets[i].tools[j])
						)
					)
				)
			)
		)
		lbx_all_tools.items = temparr
	)
	fn resizeUI new_size=
	(
		ui_max_size=[(systemTools.GetScreenWidth() - 10),(systemTools.GetScreenHeight() - 100)]
		dlg_size=slib.dlg.resizelim santexToolbox_include new_size ui_min_size ui_max_size
		
		btn_cancel.pos.y=dlg_size.y-45
		btn_ok.pos.y=dlg_size.y-45
		btn_cancel.pos.x=dlg_size.x-100
		btn_ok.pos.x=dlg_size.x-100-100-30
		btn_none.pos.y=dlg_size.y-45
		btn_none.pos.x=dlg_size.x-100-100-30-80
		
		lbx_all_tools.width = dlg_size.x - 30
		lbx_all_tools.height = dlg_size.y-85
	)
	fn getIncludeTools=
	(
		local temparr = #()
		
		return temparr
	)
	fn select_included_tools=
	(
		local curr_sel = #()
		
		getIncludeTools()
		
		if(all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].include_tools.count > 0)do
		(
			for i=1 to all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].include_tools.count do
			(
				/*local is_match = findItem all_tools_available include_tools[i]
				if(is_match > 0) do
				(
					print is_match
				)*/
				for j=1 to all_tools_available.count do
				(
					if(all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].include_tools[i].id == all_tools_available[j].id)do
					(
						--print ("i="+(i as string)+" ;  j="+(j as string))
						append curr_sel j
					)
				)
			)
		)
		
		curr_sel = curr_sel as bitarray
		lbx_all_tools.selection = curr_sel
	)
	on btn_none pressed do
	(
		lbx_all_tools.selection = #()
	)
	on btn_ok pressed do
	(
		--print lbx_all_tools.selection
		local return_arr = #()
		if(lbx_all_tools.selection.count>0)do
		(
			local lbx_all_tools_selection = lbx_all_tools.selection as array
			--print all_tools_available
			--print lbx_all_tools_selection[2]
			for i=1 to lbx_all_tools_selection.count do
			(
				append return_arr (all_tools_available[lbx_all_tools_selection[i]])
			)
		)
		all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].include_tools = return_arr
		santexToolbox_create.btn_include.text = "Include tools ("+(all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].include_tools.count as string)+")"
		destroydialog santexToolbox_include		
	)
	on btn_cancel pressed do
	(
		destroydialog santexToolbox_include
	)
	
	on santexToolbox_include resized new_size do resizeUI new_size
	on santexToolbox_include open do
	(
		slib.dlg.setSize santexToolbox_include (slib.setting.load "santexToolbox_include.size" (getDialogSize santexToolbox_include))
		resizeUI (slib.dlg.getSize santexToolbox_include)
			slib.dlg.setPos santexToolbox_include (slib.setting.load "santexToolbox_include.pos" [0,0])
			
		refresh_all_tools_list()
		select_included_tools()
	)
	on santexToolbox_include close do
	(
		slib.setting.save "santexToolbox_include.pos" (getDialogPos santexToolbox_include)
		slib.setting.save "santexToolbox_include.size" (getDialogSize santexToolbox_include)
	)
)
createdialog santexToolbox_include style:#(#style_border,#style_titlebar,#style_resizing) modal:true